﻿// ------------------------------------------------------------------------------------
//
// CrossSamples                                                  Ulrich Müller 18.07.09
//                                                               Aspire C# 2005 Express
// Beispiele zum Einsatz der Assembly CrossRoads.DLL
//
// ------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using CrossRoads40;

namespace CrossSamples {
  public partial class SamplesMain : Form {
    CrossRoads cr = new CrossRoads();
    public SamplesMain() {
      InitializeComponent();
    }

    private void cmdAction_Click(object sender, EventArgs e) {
      try {
        lstAusgabe.Items.Clear();
        cr.OpenUSB();
        lstAusgabe.Items.Add(cr.ActDevice);
        lstAusgabe.Items.Add("Schleifenende : ESC-Taste");
        switch (cboBeispiele.Text) {
          case "MultiBlinker":
            MultiBlinker();
            break;
          case "Ampel":
            Ampel();
            break;
          case "AmpelListe":
            AmpelListe();
            break;
          case "AmpelDuo":
            AmpelDuo();
            break;
          case "FußÜber":
            FussUeber();
            break;
          case "RotBlitzer":
            RotBlitzer();
            break;
          default:
            break;
        }
        lstAusgabe.Items.Add("--- FINITO ---");
        cr.CloseUSB();
      }
      catch (CrossRoadsException ecr) {
        lstAusgabe.Items.Add(ecr.Message);
      }
    }
    private void MultiBlinker() {
      uint Lampe = (uint)OutM.EM1O8;
      uint Blitzer = 0;
      lstAusgabe.Items.Add("Spielereien mit den Möglichkeiten");
      do {
        cr.SetOutputs(Blitzer + Lampe + (uint)OutM.IF1O1 + (uint)OutM.EM3O6);
        cr.Pause(444);
        cr.SetOutputs(Lampe + (uint)OutM.IF1O4 + (uint)OutM.EM3O8);
        cr.Pause(333);
        if (cr.GetInput(Inp.IF1I1)) lstAusgabe.Items.Add("Läuft - Helligkeitswert : "
           + cr.GetVoltage(Inp.A1)).ToString();
        Blitzer = cr.GetInput(Inp.EM1I6) ? (uint)OutM.EM1O7 : 0;
      } while (!cr.Finish());
    }
    private void Ampel() {
      lstAusgabe.Items.Add("Einfache Ampel");
      do {
        cr.SetOutput(Out.IF1O3, Dir.On);
        cr.Pause(3000);
        cr.SetOutput(Out.IF1O3, Dir.Off);
        cr.SetOutput(Out.IF1O2, Dir.On);
        cr.Pause(1000);
        cr.SetOutput(Out.IF1O2, Dir.Off);
        cr.SetOutput(Out.IF1O1, Dir.On);
        cr.Pause(3500);
        cr.SetOutput(Out.IF1O2, Dir.On);
        cr.Pause(1000);
        cr.SetOutput(Out.IF1O1, Dir.Off);
        cr.SetOutput(Out.IF1O2, Dir.Off);
      } while (!cr.Finish());
    }
    private enum Duos : uint {
      Rot = OutM.IF1O1 + OutM.IF1O4,
      Gelb = OutM.IF1O2 + OutM.IF1O5,
      Gruen = OutM.IF1O3 + OutM.IF1O6,
      RotQ = OutM.EM1O1 + OutM.EM1O4,
      GelbQ = OutM.EM1O2 + OutM.EM1O5,
      GruenQ = OutM.EM1O3 + OutM.EM1O6
    }
    private void AmpelDuo() {
      lstAusgabe.Items.Add("Ampelkreuzung im Duett");
      do {
        cr.SetOutputs((uint)Duos.Rot + (uint)Duos.GruenQ);
        cr.Pause(3500);
        cr.SetOutputs((uint)Duos.Gelb + (uint)Duos.GelbQ);
        cr.Pause(1000);
        cr.SetOutputs((uint)Duos.Gruen + (uint)Duos.RotQ);
        cr.Pause(3500);
        cr.SetOutputs((uint)Duos.Gelb + (uint)Duos.GelbQ);
        cr.Pause(3500);
      } while (!cr.Finish());
    }
    private void AmpelListe() {
      uint[] SchaltListe = {
                  (uint)Duos.Rot   + (uint)Duos.GruenQ,
                  (uint)Duos.Rot   + (uint)Duos.GruenQ,
                  (uint)Duos.Gelb  + (uint)Duos.GelbQ,
                  (uint)Duos.Gruen + (uint)Duos.RotQ,
                  (uint)Duos.Gruen + (uint)Duos.RotQ,
                  (uint)Duos.Gruen + (uint)Duos.RotQ,
                  (uint)Duos.Gelb  + (uint)Duos.GelbQ};
      uint Lampe = 0;
      lstAusgabe.Items.Add("Ampelkreuzung nach Liste");
      do {
        Lampe = cr.GetVoltage(Inp.A1) < 500 ? (uint)OutM.EM1O8 : Lampe = 0;
        for (int i = 0; i < SchaltListe.Length; i++) {
          cr.SetOutputs(Lampe + SchaltListe[i]);
          cr.Pause(1000);
        }
      } while (!cr.Finish());
    }
    bool FussWunsch = false;
    private void tmrFuss_Tick(object sender, EventArgs e) {
      FussWunsch = cr.GetInput(Inp.IF1I1) || cr.GetInput(Inp.IF1I2) ? true : false;
    }
    private enum DuoF : uint {
      Rot = OutM.EM2O1 + OutM.EM3O1,
      Gruen = OutM.EM2O2 + OutM.EM3O2
    }
    private void FussUeber() {
      tmrFuss.Enabled = true;
      lstAusgabe.Items.Add("Fußgängerüberweg");
      do {
        if (FussWunsch) {
          FussWunsch = false;
          cr.SetOutputs((uint)Duos.Gelb + (uint)DuoF.Rot);
          cr.Pause(1000);
          cr.SetOutputs((uint)Duos.Rot + (uint)DuoF.Gruen);
          cr.Pause(3500);
          cr.SetOutputs((uint)Duos.Gelb + (uint)DuoF.Rot);
          cr.Pause(1000);
        }
        cr.SetOutputs((uint)Duos.Gruen + (uint)DuoF.Rot);
        cr.Pause(5000);
      } while (!cr.Finish());
      tmrFuss.Enabled = false;
    }
    private bool Anforderung = false;
    private void tmrBlitzer_Tick(object sender, EventArgs e) {
      if (Anforderung) {
        if (cr.GetInput(Inp.EM1I5) && !cr.GetInput(Inp.EM1I3)) {
          cr.SetOutput(Out.EM1O7, Dir.On);
          cr.Pause(333);
          cr.SetOutput(Out.EM1O7, Dir.Off);
          Anforderung = false;
        }
      }
      else Anforderung = cr.GetInput(Inp.EM1I3);
    }
    private void RotBlitzer() {
      lstAusgabe.Items.Add("RotBlitzer ist aktiv");
      do {
        cr.SetOutputs((uint)Duos.Rot + (uint)Duos.GruenQ);
        cr.Pause(3500);
        cr.SetOutputs((uint)Duos.Gelb + (uint)Duos.GelbQ);
        cr.Pause(1000);
        cr.SetOutputs((uint)Duos.Gruen + (uint)Duos.RotQ);
        tmrBlitzer.Enabled = true;
        cr.Pause(3500);
        tmrBlitzer.Enabled = false;
        cr.SetOutputs((uint)Duos.Gelb + (uint)Duos.GelbQ);
        cr.Pause(1000);

      } while (!cr.Finish());
    }

    private void SamplesMain_Load(object sender, EventArgs e) {
      cboBeispiele.SelectedIndex = 0;
    }

  }
}