﻿// --------------------------------------------------------------------------------------
//
// eduLine.CS                                                      Ulrich Müller 16.07.09
//                                                                 Aspire         C# 2005
// Statische Klasse mit Deklarationen für education Line
//                      Basis eduLine.DLL
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace eduLine {
  public enum IFTypen {
    first_USB              = 0,
    ROBO_Interface_USB     = 60,
    EDU_LINE_Module        = 300,
    EDU_LINE_CrossRoads    = 301,
    EDU_LINE_TrafficLights = 302,
    EDU_LINE_Signal        = 303
  }
  public class eduLine {
		static eduLine()	{}

		// --- eduLine.DLL Deklarationen ----------------------------------------
		[DllImport("eduLine.DLL")]
		public static extern uint edOpenUSB(int ifTyp, int SerialNr);
    [DllImport("eduLine.DLL")]
		public static extern uint edCloseUSB(uint iHandle);

    [DllImport("eduLine.DLL")]
		public static extern int edGetInput(uint iHandle, int InputNr);
    [DllImport("eduLine.DLL")]
		public static extern int edGetInputs(uint iHandle);
    [DllImport("eduLine.DLL")]
		public static extern int edGetVoltage(uint iHandle, int VoltNr);

    [DllImport("eduLine.DLL")]
		public static extern uint edGetOutputs(uint iHandle);
    [DllImport("eduLine.DLL")]
		public static extern uint edSetOutputs(uint iHandle, uint MotorStatus);
    [DllImport("eduLine.DLL")]
		public static extern uint edSetOutput(uint iHandle, int LampNr, int OnOff);

    [DllImport("eduLine.DLL")]
		public static extern uint edGetActDeviceType(uint iHandle);
    [DllImport("eduLine.DLL")]
		public static extern uint edGetActDeviceSerialNr(uint iHandle);
    [DllImport("eduLine.DLL")]
		public static extern uint edGetActDeviceFirmwareNr(uint iHandle);

		public const uint edFehler = 0xE0000001;

		// --- Win API Deklarationen ----------------------------------------------------

		[DllImport("kernel32")]
		public static extern void Sleep(uint mSek);
		[DllImport("kernel32")]
		public static extern uint GetTickCount();
		[DllImport("user32")]
		public static extern uint GetAsyncKeyState(uint vKey);
		public const uint ESCAPE = 0x1B;
  }
}
