import eduLine.*;
/**
 * Verschiedene Ampeln 
 *
 * @author Ulrich Mller
 * @version 26.12.09
 */
public class Ampeln
{
    private CrossRoads cr;
    private boolean fussWunsch;
    private boolean anforderung;
    private boolean rotActive;
    
    public Ampeln()
    {
        cr = new CrossRoads();
        cr.openUSB(0, 0);
    }

    public void dreierAmpel()
    {
        System.out.println("dreierAmpel gestartet");
        do {
            cr.setOutput(Out.EM1O3, Dir.On);
            cr.pause(3000);
            cr.setOutput(Out.EM1O3, Dir.Off);
            cr.setOutput(Out.EM1O2, Dir.On);
            cr.pause(1000);
            cr.setOutput(Out.EM1O2, Dir.Off);
            cr.setOutput(Out.EM1O1, Dir.On);
            cr.pause(3500);
            cr.setOutput(Out.EM1O2, Dir.On);
            cr.pause(1000);
            cr.setOutput(Out.EM1O1, Dir.Off);
            cr.setOutput(Out.EM1O2, Dir.Off);
        } while(!cr.finish());
        System.out.println("--- Finito ---");
    }
    public void paarAmpeln() {
        System.out.println("paarAmpeln gestartet");
        do {
            cr.setOutputs(Duos.Gruen);
            cr.pause(3000);
            cr.setOutputs(Duos.Gelb);
            cr.pause(1000);
            cr.setOutputs(Duos.Rot);
            cr.pause(3500);
            cr.setOutputs(Duos.RotGelb);
            cr.pause(1000);
        } while(!cr.finish());
        System.out.println("--- Finito ---");
    }
    public void listenAmpeln() {
        int lampe;
        int[] takte = new int[] {
            Duos.Rot + Duos.GruenQ, Duos.Rot + Duos.GruenQ,
            Duos.Gelb + Duos.GelbQ,
            Duos.Gruen + Duos.RotQ, Duos.Gruen + Duos.RotQ, 
            Duos.Gruen + Duos.RotQ,
            Duos.Gelb + Duos.GelbQ
        };
        System.out.println("listenAmpeln gestartet");
        do {
            lampe = cr.getVoltage() < 500 ? OutM.EM1O8 : 0;
            for(int i = 0; i < takte.length; i++) {
                cr.setOutputs(lampe + takte[i]);
                cr.pause(1000);
            }
        } while(!cr.finish());
        cr.clearOutputs();
        System.out.println("--- Finito ---");
    }
    private class FussTaste implements Runnable {
        @Override public void run() {
            do {
                fussWunsch = cr.getInput(Inp.IF1I1) || cr.getInput(Inp.IF1I2);
                cr.pause(123);
            } while (!cr.finish());
        }
    }
    public void fussAmpel() {
        Thread fuss = new Thread (new FussTaste());
        fuss.start();
        System.out.println("fussAmpeln gestartet");
        do {
            if(fussWunsch) {
                fussWunsch = false;
                cr.setOutputs(Duos.GelbQ + Duos.RotF);
                cr.pause(1000);
                cr.setOutputs(Duos.RotQ + Duos.GruenF);
                cr.pause(3500);
                cr.setOutputs(Duos.GelbQ + Duos.RotF);
                cr.pause(1000);
            }
            cr.setOutputs(Duos.GruenQ + Duos.RotF);
            cr.pause(1000);
        } while(!cr.finish());
        cr.clearOutputs();
        System.out.println("--- Finito ---");
    }
    private class Blitzen  implements Runnable {
        @Override public void run() {
            do {
                if(anforderung && rotActive) {
                    if(cr.getInput(Inp.EM1I5) && !cr.getInput(Inp.EM1I3)) {
                       cr.setOutput(Out.EM1O7, Dir.On);
                       cr.pause(444);
                       cr.setOutput(Out.EM1O7, Dir.Off);
                       anforderung = false;
                    }
                }
                else anforderung = cr.getInput(Inp.EM1I3);
                cr.pause(123);
            } while(!cr.finish());
        }
    }
    public void rotBlitzer() {
        anforderung = false;
        rotActive = false;
        Thread blitz = new Thread (new Blitzen());
        blitz.start();
        System.out.println("rotBlitzer ist aktiv");
        do {
            cr.setOutputs(Duos.Rot + Duos.GruenQ);
            rotActive = true;
            cr.pause(3500);
            rotActive = false;
            cr.setOutputs(Duos.Gelb + Duos.GelbQ);
            cr.pause(1000);
            cr.setOutputs(Duos.Gruen + Duos.RotQ);
            cr.pause(3500);
            cr.setOutputs(Duos.Gelb + Duos.GelbQ);
            cr.pause(1000);
        } while(!cr.finish());
        cr.clearOutputs();
        System.out.println("--- Finito ---");
    }
}
