import eduLine.*;
/**
 * Erkunden der CrossRoads-Komponenten
 * 
 * @author Ulrich Mller
 * @version 26.12.09
 */
public class Elemente
{
    private CrossRoads cr;
    public Elemente()
    {
        cr = new CrossRoads();
        cr.openUSB(0, 0);
    }

    /**
     * Ausgabe der Liste der Outputs, nach jedem Eintrag Fuss links unten bettigen
     */
    public void outListe()
    {
        System.out.println("outListe gestartet");
        for(int i = 1; i <= 32; i++) {
            Out O = Out.values()[i];
            System.out.println("Out." + O);
            cr.setOutput(O, Dir.On);
            cr.waitForHigh(Inp.IF1I6);
            cr.setOutput(O, Dir.Off);
        }
        System.out.println("--- FINITO ---");
    }
    
    /**
     * Anzeige eines bettigten Fugngertasters
     */
    public void fussListe()
    {
        System.out.println("fussListe gestartet");
        do {
            int iWert = cr.getInputs();
            int maske = 1;
            for(int i = 1; i <= 8; i++) {
                if((iWert & maske) > 0) System.out.println("Inp." + Inp.values()[i]);
                maske *= 2;
            }
            cr.pause(333);
        } while(!cr.finish());
        System.out.println("--- FINITO ---");
    }
    
    /**
     * Anzeige eines befahrenen Kanaldeckels
     */
    public void deckelListe()
    {
        System.out.println("deckelListe gestartet");
        do {
            int iWert = cr.getInputs();
            int maske = 256;
            for(int i = 1; i <= 6; i++) {
                if((iWert & maske) > 0) System.out.println("Inp." + Inp.values()[i + 8]);
                maske *= 2;
            }
            cr.pause(333);
        } while(!cr.finish());
        System.out.println("--- FINITO ---");
    }
    
    /** 
     * Aulsen eines Radarblitzes bei berfahren des Kanaldeckels links unten 
     */
    public void radarBlitz() {
        System.out.println("radarBlitz gestartet");
        do {
            cr.waitForLow(Inp.EM1I3);
            cr.setOutput(Out.EM1O7, Dir.On);
            System.out.println("hat ihn");
            cr.pause(333);
            cr.setOutput(Out.EM1O7, Dir.Off);
        } while(!cr.finish());
        System.out.println("--- FINITO ---");
    }
    
    /**
     * Schalten der Lampe, wenns zu dunkel wird
     */
    public void helligkeit() {
        System.out.println("helligkeit gestartet");
        do {
            int hell = cr.getVoltage();
            if(hell < 555) cr.setOutput(Out.EM1O8, Dir.On);
            else if(hell > 631) cr.setOutput(Out.EM1O8, Dir.Off);
            System.out.println("Helligkeitswert : " + hell);
            cr.pause(1234);
        } while(!cr.finish());
        System.out.println("--- FINITO ---");
    }
}
